<template>
  <div>
    <el-page-header content="详情" style=" padding: 20px 20px 0 20px;" @back="handleBack" />
    <return-sales-header ref="header" :details="details" />
    <sales-table :data-list="dataList" :column="column" @handleSelection="handleSelection">
      <template #bts>
        <div>
          <el-button type="primary" size="mini" @click="dialogVisible=true">添加</el-button>
          <el-button type="danger" size="mini" @click="delChange">删除</el-button>
        </div>
      </template>
      <template #events>
        <div>
          <el-button type="primary" size="mini" @click="handleInform(2)">通知发货</el-button>
          <el-button size="mini">撤销发货</el-button>
        </div>
      </template>

      <template v-slot:custom="{item:{row,$index}}">
        <el-radio v-model="row.flag" label="1">增加</el-radio>
        <el-radio v-model="row.flag" label="-1">减少</el-radio>
      </template>
      <template v-slot:operation="{item:{row,$index}}">
        <el-popconfirm
          style="margin-left: 10px"
          title="删除？"
          @confirm="handleDel(row,$index)"
        >
          <el-button slot="reference" type="text" size="mini">删除</el-button>
        </el-popconfirm>
      </template>
    </sales-table>
    <LogisticsTabs />
    <sales-dialog
      :dialog-visible="dialogVisible"
      :customer-number="customerNumber"
      :func="getDialogList"
      @confirm="confirm"
    />
  </div>
</template>

<script>
import SalesDialog from '@/components/SalesDialog/SalesDialog'
import ReturnSalesHeader from '@/components/ReturnSalesHeader/ReturnSalesHeader'
import SalesTable from '@/components/SalesTable/SalesTable'
import { addFrontOrder, detailRefund, sbumitFrontOrder, sendRefund } from '@/api/sales'
import { getcustomerFrontList } from '@/api/stock'
import LogisticsTabs from '@/components/LogisticsTabs'

export default {
  name: 'WarehouseForm',
  components: {
    ReturnSalesHeader,
    SalesTable,
    SalesDialog,
    LogisticsTabs
  },
  props: ['detailsId', 'pageType'],
  data() {
    return {
      dialogVisible: false,
      customerNumber: '',
      dataList: [],
      selection: [],
      flag: 1,
      details: {},
      column: [
        {
          prop: 'materialName',
          label: '产品名称',
          width: '180'
        },
        {
          prop: 'materialOldNumber',
          label: '物料编码',
          width: '180'
        },
        {
          prop: 'specification',
          label: '规格型号',
          width: '300'
        },
        {
          prop: 'stockLockQty',
          label: '库存数量',
          width: '180'
        },
        {
          prop: 'qty',
          label: '数量',
          width: '180'
        },
        {
          prop: 'volume',
          label: '体积',
          width: '180'
        },
        {
          prop: 'totalVolume',
          label: '总体积',
          width: '180'
        },
        {
          prop: 'notes',
          label: '备注',
          width: '180'

        }
      ]
    }
  },
  created() {
    if (this.detailsId) {
      detailRefund({ id: this.detailsId }).then(res => {
        this.dataList = res.data.orders
        this.details = res.data
      })
    }
  },
  methods: {
    getDialogList(p) {
      return getcustomerFrontList(...p)
    },
    confirm(selected) {
      // console.log(selected)
      this.dataList = selected
      this.$refs.header.screenForm.customerName = this.dataList[0].customerName
      this.$refs.header.screenForm.customerNumber = this.dataList[0].customerNumber
      this.customerNumber = this.dataList[0].customerNumber
      this.dialogVisible = false
    },
    handleDel(item, index) {
      this.dataList.splice(index, 1)
    },
    delChange() {
      this.dataList.forEach((k, i) => {
        this.selection.forEach((l, e) => {
          if (k.id === l.id) {
            this.dataList.splice(i, 1)
            this.selection.splice(e, 1)
          }
        })
      })
    },
    handleSelection(data) {
      this.selection = data
    },
    handleInform(status = 2) {
      console.log(33)
      sendRefund({ id: this.details.id, status }).then(res => {
        this.$successMsg('退货通知')
      })
    },
    handelSubmit() {
      this.dataList.forEach(k => {
        k.id = ''
        k.directFlag = k.flag
      })
      const params = {
        ...this.$refs.header.screenForm,
        orders: this.dataList
      }
      addFrontOrder(params).then(res => {
        this.$successMsg('新增成功')
        this.handleBack()
        this.$forceUpdate()
      })
    },
    handleBack() {
      this.$emit('close')
    }

  }
}
</script>

<style scoped>

</style>
